// PXEWIN - (C) Copyright 1992 by Beam Engineering, INC.

// PXEFAM.CPP //

// Contents ----------------------------------------------------------------
//
//	This module contains members for the PXFamily class.
//
// End ---------------------------------------------------------------------

// External Reference Name for this Header ---------------------------------

#ifndef PXEFAM_CPP
	#define PXEFAM_CPP

// End ---------------------------------------------------------------------

// Interface Dependencies --------------------------------------------------

#ifndef PXEOBJ_HPP
	#include "pxeobj.hpp"
#endif // PXEOBJ_HPP

// End ---------------------------------------------------------------------

// constructor PXFamily //

inline PXFamily::PXFamily()
{
	EngDataPtr = new EngData;
}

// Summary -----------------------------------------------------------------
//
//	Create a new engine data pointer.
//
// End ---------------------------------------------------------------------

// destructor PXFamily //

inline PXFamily::~PXFamily()
{
	delete EngDataPtr;
}

// Summary -----------------------------------------------------------------
//
//	Delete engine data pointer.
//
// End ---------------------------------------------------------------------

// member Delete of PXFamily //

inline int PXFamily::Delete(Pchar name)
{
	if((EngDataPtr->Errors.pxerr = PXTblDelete(name)) != PXSUCCESS)
		PXError(ENG_ERROR);
	return EngDataPtr->Errors.pxerr;
}

// Summary -----------------------------------------------------------------
//
//	Deletes a family of files.
//
// Parameters
//
//	name.  Name of family.
//
// Return Value
//
// 	pxerr.  Is PDOX error status.
//
// End ---------------------------------------------------------------------

// member Copy of PXFamily //

inline int PXFamily::Copy(Pchar source,Pchar dest)
{
	if((EngDataPtr->Errors.pxerr = PXTblCopy(source,dest)) != PXSUCCESS)
		PXError(ENG_ERROR);
	return EngDataPtr->Errors.pxerr;
}

// Summary -----------------------------------------------------------------
//
//	Copy associated files from one family to another.
//
// Parameters
//
//	source.  Is the family name of the source files.
//
//	dest.  Is the family name of the destination files.
//
// Return Value.
//
//	pxerr.  Return PDOX error status.
//
// End ---------------------------------------------------------------------

#endif // PXEFAM_CPP //