// PXEWIN - (C) Copyright 1992 by Beam Engineering, INC.

// PXEFAM.HPP //

// Contents ----------------------------------------------------------------
//
//	This module contains the PXFamily class object.
//
// End ---------------------------------------------------------------------

// External Reference Name for this Header ---------------------------------

#ifndef PXEFAM_HPP
	#define PXEFAM_HPP

// End ---------------------------------------------------------------------

// Interface Dependencies --------------------------------------------------

#ifndef PXEOBJ_HPP
	#include "pxeobj.hpp"
#endif // PXEOBJ_HPP //

// End ---------------------------------------------------------------------

// class PXFamily //

_CLASSDEF(PXFamily)
class PXFamily:public PXEngObject
{
public:
	PXFamily();
	~PXFamily();
	int Delete(char *name);			/* Deletes a database family
						*/
	int Copy(char *source,char *dest);	/* Copy a source family to
						   it's destination */
};

// Description -------------------------------------------------------------
//
//	This class is implimented to seperate out those functions that are
//	specifically related to a Paradox family.  Since they perform family
//	operations, it's logical to seperate them from the table class.
//	Also, when Borland (hopefully) impliments more family related
//	functionality, the destinction maybe more important.
//
// Note --------------------------------------------------------------------
//
//	Assumes PXEngObject's PXError handler.
//
// End ---------------------------------------------------------------------

#endif // PXEFAM_HPP //