// PXEWIN - (C) Copyright 1992 by Beam Engineering, INC.

// PXREC.HPP //

// Contents ----------------------------------------------------------------
//
//	PXRec.  This module contains the PXRec class for interfacing the
//	engine to the PDOX Engine record related functions.
//
// End ---------------------------------------------------------------------

// External Reference Name for this Header ---------------------------------

#ifndef PXREC_HPP
	#define PXREC_HPP

// Interface Dependencies --------------------------------------------------

#ifndef PXEOBJ_CPP
	#include "pxeobj.cpp"
#endif // PXEOBJ_CPP //

// End ---------------------------------------------------------------------

// class PXRec //

_CLASSDEF(PXRec)
class PXRec:public PXEngObject{
private:
	virtual const Pchar streamableName()
	const					/* Defines the streamable
						   name for this class. */
	{
		return "PXRec";
	}
protected:
	virtual Pvoid read(Ripstream);		/* Read persistant object */
	virtual void write(Ropstream);		/* Write persistant object */
	PXRec(StreamableInit):			/* Persistant object
						   constructor */
		PXEngObject(streamableInit)
	{

	}
public:
	PXRec(PPXEngObject my_engobj);		/* Copies parent object on
						   construction */
	static PTStreamable build();		/* Build persistant object */
	virtual ~PXRec();
	int Get();				/* Get current record */
	int Update();				/* Updata the current record
						   with tx buffer data */
	int RecPrev();                   	/* Go to previous record */
	int RecNext();				/* Go to next record */
	int GoTo(RECORDNUMBER recNum);		/* Go to a record */
	virtual void PXError(int org);		/* PXRec error handler */
};

// Description -------------------------------------------------------------
//
//	This class contains constructors, destructors and members needed to
//	access a record in a Paradox table.  It uses PXENGINE function calls.
//
// End ---------------------------------------------------------------------

// Define inserters and extractors for persistant objects:

inline Ripstream operator >> (Ripstream is,RPXRec cl)
	{return is >> (RTStreamable)cl;}

inline Ripstream operator >> (Ripstream is,RPPXRec cl)
	{return is >> (RPvoid)cl;}

inline Ropstream operator << (Ropstream os,RPXRec cl)
	{return os << (RTStreamable)cl;}

inline Ropstream operator << (Ropstream os,PPXRec cl)
	{return os << (PTStreamable)cl;}

#endif // PXREC_HPP //